DROP DATABASE IF EXISTS mvsops;
CREATE DATABASE mvsops;
CONNECT mvsops;

DROP TABLE IF EXISTS `users`;
CREATE TABLE IF NOT EXISTS `users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `username` varchar(60) NOT NULL,
  `password` varchar(120) NOT NULL COMMENT 'Hashed Password',
  `mvsname` varchar(8) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `username` (`username`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=ascii;

INSERT INTO `users` (`username`, `password`, `mvsname`) 
VALUES ('admin', '$2y$10$aTT5psA53FkNNvQ8m4rU2u8SAlRTWqwr5WamGMYyhpvJ4Ye4kxng6', 'herc01');

DROP TABLE IF EXISTS `features`;
CREATE TABLE IF NOT EXISTS `features` (
  `id` int(11) NOT NULL,
  `object` varchar(8),
  CONSTRAINT `id_obj` PRIMARY KEY (`id`, `object`)
);

INSERT INTO `features` (`id`, `object`) SELECT id, 'admin'  FROM users WHERE `username` = 'admin';
INSERT INTO `features` (`id`, `object`) SELECT id, 'output' FROM users WHERE `username` = 'admin'; 
INSERT INTO `features` (`id`, `object`) SELECT id, 'reader' FROM users WHERE `username` = 'admin'; 
INSERT INTO `features` (`id`, `object`) SELECT id, 'console'FROM users WHERE `username` = 'admin';
INSERT INTO `features` (`id`, `object`) SELECT id, 'input'  FROM users WHERE `username` = 'admin';
INSERT INTO `features` (`id`, `object`) SELECT id, 'tape'   FROM users WHERE `username` = 'admin';
INSERT INTO `features` (`id`, `object`) SELECT id, 'ipl'    FROM users WHERE `username` = 'admin';

DROP USER IF EXISTS 'mvs_ops_user'@'localhost';
CREATE USER 'mvs_ops_user'@'localhost' IDENTIFIED BY 'mvs_secret';
GRANT SELECT, INSERT, UPDATE, DELETE ON `mvsops`.`users` TO 'mvs_ops_user'@'localhost';
GRANT SELECT, INSERT, UPDATE, DELETE ON `mvsops`.`features` TO 'mvs_ops_user'@'localhost';

