<?php
require_once("../lib/common.php");
if ( ! SECURED)
	header("location: ../index.php");

$authorised = check_auth_ok("admin");

if ( ! $authorised ) {
	header('HTTP/1.0 401 Unauthorized');
	echo "<h1>You don't have sufficient privileges to access the user admin facility.</h1>";
	exit(1);
}

?>
<!DOCTYPE html>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<html>
<title>
MVS Ops User Administration (<?php echo gethostname(); ?>)
</title>
<head>
<link rel="stylesheet" type="text/css" href="../lib/core.css" media="screen" >
</head>
<body>
<header>
<?php
do_header("MVS Ops User Administration");
?>
</header>
<nav>
<?php show_nav("admin", ".."); ?>
</nav>
<article>
<?php 
	require_once("../lib/db.php");
	
	$db = mysqli_connect(DB_SERVER,DB_USERNAME,DB_PASSWORD,DB_DATABASE);	
	$attributes = array(
		array('username', 'text'),
		array('password', 'password'),
		array('mvsname', 'text'),
		array('output', 'checkbox'),
		array('reader', 'checkbox'),
		array('console', 'checkbox'),
		array('input','checkbox'),
		array('tape', 'checkbox'),
		array('admin', 'checkbox'),
		array('ipl', 'checkbox')
		);
		
	if ( isset($_REQUEST['action'])) {
		if ( $_REQUEST['action'] === 'update') {
			// check we're not disabling the last admin user!
			$result = mysqli_query($db, "SELECT count(1) FROM features WHERE object ='admin'");
			$row = mysqli_fetch_array($result);
			$admincount = $row[0];
			
			$id = (int)$_REQUEST['id'];

			$result = mysqli_query($db, "SELECT 1 FROM features WHERE object = 'admin' AND id = $id");
			$row = mysqli_fetch_array($result);
			$isadmin = $row[0];
			if ($admincount == 1 && $isadmin == 1 && ! isset($_REQUEST["admin"])) 
				echo "Cannot remove admin authority from the only admin user";
			else
			{
				$sql = "UPDATE users SET ";
				$pos = 0;	// position in line, used to control intermediate commas
				foreach ($attributes as $a) { 
					if ($a[1] === 'password' && isset($_REQUEST[$a[0]]) && $_REQUEST[$a[0]] != "") {
						if ($pos++)
							$sql .= " , ";
						$sql .= $a[0].' = "'.password_hash($_REQUEST[$a[0]], PASSWORD_DEFAULT).'"';
					} else if ($a[1] === 'text' && isset($_REQUEST[$a[0]]) && $_REQUEST[$a[0]] != "") {
						if ($pos++)
							$sql .= " , ";
						$sql .= $a[0].' = "'.$_REQUEST[$a[0]].'"';
					}
					
				}
				$sql .= " WHERE id = $id";
				$result = mysqli_query($db,$sql);
				if ( !$result )
					echo ("Update user failed ".$db->error);
				
				// delete all user's permission and insert only set entries
				$sql = "DELETE FROM features WHERE id = ".$_REQUEST['id'];
				$result = mysqli_query($db,$sql);
				if ( !$result )
					echo ("Delete existing user features failed ".$db->error);
				
				foreach ($attributes as $a) {
					if ($a[1] === 'checkbox' && isset($_REQUEST[$a[0]])) {
						$sql = "INSERT INTO features(id, object)";
						$sql .= "VALUES ( ".$_REQUEST['id'].",'".$a[0]."')";

						$result = mysqli_query($db,$sql);
						if ( !$result )
							echo ("Insert existing user features failed ".$db->error);
					}
				}
			}
		} else 	if ( $_REQUEST['action'] === 'delete') {
			// check not deleting last user !
			$result = mysqli_query($db, "SELECT count(1) FROM users");
			$row = mysqli_fetch_array($result);
			$users = $row[0];
			if ($users == 1) 
				echo "Cannot delete last user";
			else
			{
				$id = (int)$_REQUEST['id'];
				
				$sql = "DELETE FROM users WHERE id = $id";
				$result = mysqli_query($db,$sql);
				if ( !$result )
					echo ("Delete user failed ".$db->error);
				
				$sql = "DELETE FROM features WHERE id = $id";
				$result = mysqli_query($db,$sql);
				if ( !$result )
					echo ("Delete user features failed ".$db->error);
			}
		} else 	if ( $_REQUEST['action'] === 'new' && strlen($_REQUEST['username']) > 0) {
			
			$sql = "INSERT INTO users(username, password, mvsname) VALUES (";
			$first = 1;
			foreach ($attributes as $a) {
				if ($a[1] === 'password' && isset($_REQUEST[$a[0]])) {
					$sql .= ',"'.password_hash($_REQUEST[$a[0]], PASSWORD_DEFAULT).'"';
				} else if ($a[1] === 'text' && isset($_REQUEST[$a[0]])) {
					if ($first ) 
						$first = 0;
					else
						$sql .= " , ";
					$sql .= '"'.mysqli_real_escape_string($db, $_REQUEST[$a[0]]).'"';
				}
			}
			$sql .= ")";
			$result = mysqli_query($db,$sql);
			if ( !$result )
				echo ("Insert new user failed ".$db->error);
			$newid = mysqli_insert_id($db);
			// now add in the features
			foreach ($attributes as $a) {
				if ($a[1] === 'checkbox' && isset($_REQUEST[$a[0]])) {
					$sql = "INSERT INTO features(id, object) VALUES ( $newid, '".$a[0]."')";
					$result = mysqli_query($db,$sql);
					if ( !$result )
						echo ("Insert new user permission failed ".$db->error);
				}
			}
		}
	}
	// display form showing current users and admin options
	
	$sql = "SELECT * FROM users";

	$result = mysqli_query($db,$sql);
	if ( !$result )
	      die("Unable to access users database.");

	$count = mysqli_num_rows($result);


	echo "<table>";
	foreach ($attributes as $a) {
		echo "<th>".$a[0]."</th>";
	}
	for ($i = 0; $i < $count; $i++) {	
		$row = mysqli_fetch_array($result,MYSQLI_ASSOC);
		echo "<tr>";
		echo '<form name="admin_'.$i.'" action="" method="POST">';
		echo '<input type="hidden" name="id" value="'.$row['id'].'">';
		foreach ($attributes as $a) {
			if ($a[1] === 'text') 
				echo '<td><input type="text" name="'.$a[0].'" value="'.$row[$a[0]].'"></td>';
			else if ($a[1] === 'password')
				echo '<td><input type="password" name="'.$a[0].'" value=""></td>';
		}
		foreach ($attributes as $a) {
			if ($a[1] === 'checkbox') {
				$sql = "SELECT 1 FROM features where object = '".$a[0]."' AND id = ".$row['id'];
				$r2 = mysqli_query($db, $sql);
				$enabled = mysqli_fetch_array($r2);
				echo '<td><input type="checkbox" name="'.$a[0].'" '.($enabled[0] ? 'checked' : '').'></td>';
			}
		}
?>
		<td><input type="submit" name="action" value="update"></td>
		<td><input type="submit" name="action" value="delete"
			onClick="return confirm('Really delete <?php echo $row['username'] ?> ?');"></td></form>
		</tr>
<?php
	}
	// add new user line
	echo "<tr>";
	echo '<form name="admin_new" action="" method="POST">';
	foreach ($attributes as $a) {
		if ($a[1] === 'text') 
			echo '<td><input type="text" name="'.$a[0].'" value=""></td>';
		else if ($a[1] === 'password')
			echo '<td><input type="password" name="'.$a[0].'" value=""></td>';
		else if ($a[1] === 'checkbox')
			echo '<td><input type="checkbox" name="'.$a[0].'"></td>';
	}
	echo '<td><input type="submit" name="action" value="new"></td></form>';
	echo "</tr>\n";

?>
</table>
</article>
</body>
</html>