<?php
# program to scrape the console file in the background
require_once("../lib/common.php");

if (!file_exists($CONSOLE_PATH))
{
	header ("HTTP/1.1 404 Not Found");
	return;
}
$fm = @fopen($CONSOLE_PATH, 'rb');
if (!$fm)
{
	header ("HTTP/1.1 505 Internal server error");
	return;
}
$time  = date('r', filemtime($CONSOLE_PATH));
$size  = filesize($CONSOLE_PATH);
    
$begin  = 0;
$end  = $size;

if ($size === 0) // no content so reflect recoverable error back
{
	header('HTTP/1.1 204 OK');
	exit(0);
}

if (isset($_SERVER['HTTP_RANGE']))
{
	if (preg_match('/bytes=[\t ]*([\-]*\d+)[\-]*(\d*)[\D.*]?/i', $_SERVER['HTTP_RANGE'], $matches))
	{
		$begin  = intval($matches[1]);
		if (!empty($matches[2]))
		{
			$end  = intval($matches[2]);
		}
		if ($begin < 0)	// from end of file
			$begin = $end + $begin;
		if ($begin < 0) $begin = 0;
	}
  
	// error_log( $_SERVER['HTTP_RANGE']."  Match :$matches[1]:$matches[2]: Begin $begin End $end");
	header('HTTP/1.1 206 Partial Content');
}
else
{
	header('HTTP/1.1 200 OK');
}
   
header("Content-Type: text/html");
//header('Cache-Control: public, must-revalidate, max-age=0');
//header('Pragma: no-cache');  
header('Accept-Ranges: bytes');
header('Content-Length:' . ($end - $begin));
header("Content-Range: bytes $begin-$end/$size");
header("Content-Disposition: inline; filename=CONSOLE.LOG");
//header("Content-Transfer-Encoding: binary");
header("Last-Modified: $time");

// send range specified
fseek($fm, $begin, 0);
// NOTE: no htmlspecialchars as this messes up length of file! Going to textarea for output only anyway so no worries
if ($end > $begin)
{
	print fread($fm, ($end - $begin));
}

?>
