<?php
require_once("../lib/common.php");
$authorised = check_auth_ok("console");

if( ! $authorised ) {
	header('HTTP/1.0 401 Unauthorized');
	echo "<h1>You don't have sufficient privileges to access the console subsystem.</h1>";
	exit(1);
}
// if we are called with a command submit to the Hercules console and return
if ( strlen($CONS_INPUT) > 0 && isset($_REQUEST['cmd'])) {
	$cmd = trim($_REQUEST['cmd']);
	if ($cmd === "") {
		$msg = "No command.";
		http_response_code(200);
	} else {	
		$url = $CONS_INPUT."/cgi-bin/tasks/syslog";
		$sendcmd = 'command=';

		// if cmd starts with \ then strip it and pass command raw to Hercules
		// otherwise add leading slash to force command to MVS rather than Hercules
		// Explicity prevent a sh being issued but all other Hercules commands are allowed!
		if (substr($cmd, 0, 1) === "\\") {
			$cmd = substr($cmd, 1);		// strip leading backslash
			if (preg_match('/\A\s*sh\b/', $cmd) === 1) {
				//  SH COMMAND IS DISABLED BY THE WEB INTERFACE";
				http_response_code(403);	// forbidden
				exit;
			}
		} else	
			$sendcmd .= '/'; 	// force to MVS console
		$sendcmd .= urlencode($cmd) . '&send=send';
		
		$ch = curl_init( $url );
		curl_setopt( $ch, CURLOPT_POST, 1);
		curl_setopt( $ch, CURLOPT_POSTFIELDS, $sendcmd);
		curl_setopt( $ch, CURLOPT_FOLLOWLOCATION, 1);
		curl_setopt( $ch, CURLOPT_HEADER, 0);
		curl_setopt( $ch, CURLOPT_RETURNTRANSFER, 1);

		$response = curl_exec( $ch );
		http_response_code($response === false ? 503 : 200); // unavailable : okay
	}
	exit;
}
?>
<!DOCTYPE html>
<html>
<head>
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>
MVS Console (<?php echo gethostname(); ?>)
</title>
<script type="text/javascript" src="../lib/jquery-3.4.1.min.js"></script>
<script type="text/javascript" src="consoletail.js"></script>
<link rel="stylesheet" type="text/css" href="../lib/core.css" media="screen" >
</head>
<body>
<?php 
do_header("MVS Console");
?>
<nav>
<?php show_nav("console", ".."); ?>
<br>
<button id="pause" href='#'>Pause</button><br><br>
<button id="GotoEnd" href='#'>Current</button><br><br>
Update Interval
<input type="text" id="poll" value="5" size="3">seconds
<input type="hidden" id="lines" value="1000" size="5"><br><br>
<b><a href="listlog.php" target="Console log"><img src="../printer/icon.php?text=PRINT%0A%20CONSOLE%0A%20%20LOG" alt="Print Log"></a></b>
<?php
if ( strlen($IPL_CMD) > 1 && ! SECURED || check_auth_ok("ipl")) {
?>
<form action="../console/ipl.php" target='ipl' method="POST">
<button type="submit" style="background-color:red; font-size:large;"><b>IPL</b></button>
</form>
<?php
}
?>
</nav>
<section>
<pre id="data" class="logwindow" >Loading...</pre>
<?php
if (check_auth_ok("input") && strlen($CONS_INPUT) > 0) {
?>
<form id="cmd_line">
<input type="text" id="cmd" size="80" class="cmdwindow">
<br><br>
<input type="submit" value="Enter" id="send" class="button" style='background-color:green;' >
<input type="button" value="Clear" onclick='document.getElementById("cmd").value = "";document.getElementById("cmd").focus();' 
       class="button"  style='display: inline;' >
<b>Status: <div id="rdrmsg" style='display: inline;'>Ready</div></b>
<script>
document.getElementById("cmd").focus();
</script>
</form>
<?php
}
?>
</section>
</body>
</html>