 <?php
require_once("../lib/common.php");

$authorised = check_auth_ok("ipl");

if ( ! $authorised ) {
	header('HTTP/1.0 401 Unauthorized');
	echo "<h1>You don't have sufficient privileges to access the IPL facility.</h1>";
	exit(1);
}

?>
<!DOCTYPE html>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<html>
<title>
MVS Ops Start MVS(<?php echo gethostname(); ?>)
</title>
<head>
<link rel="stylesheet" type="text/css" href="../lib/core.css" media="screen" >
</head>
<body>
<header>
<?php
do_header("MVS Ops Power On IPL MVS");
?>
</header>
<nav>
<?php show_nav("", ".."); ?>
</nav>
<article>
<?php

$iplstr = "IPL 148";

function hardexit($msg = "")
{
	echo "<br><b>$msg</b></br></article></body></html>";
	exit();
}

if (strlen($IPL_CMD) < 1)
	hardexit("IPL_CMD not set in config.php");

if ( ! is_readable($IPL_CMD))
	hardexit("IPL_CMD is not readable by the webserver. Check config.php.");

if (isset($_REQUEST['ipl'])) {
	if (SECURED) {
		if ( ! password_verify($_REQUEST['ipl'], $_SESSION['password']))
			$err = "Invalid password. No IPL issued";
	} else if ($_REQUEST['ipl'] != $iplstr) 
		$err = "$iplstr not entered. No IPL issued";
	
	if ( ! isset($err)) {
		echo "MVS IPL started<br><br>";
		session_write_close();
		echo "Issuing => $IPL_CMD <br>";
		
		if (substr(php_uname(), 0, 7) == "Windows"){ 
			pclose(popen("start /b $IPL_CMD", "r")); 
		} else { 
			echo (system("$IPL_CMD >/dev/null 2>&1 &", $rc));  
		} 

		echo "<br>MVS IPL issued";
		hardexit();
	} else
		echo "<br><br><b>$err</b><br><br>";
} 
?>
<form method="POST">
<?php
if ( SECURED){
?>
	<br><br><b>Enter your password to issue Power On IPL : </b><input type="password" name="ipl">
<?php
} else {
?>
	<br><br><b>Type <?php echo $iplstr;?> to issue Power On IPL : </b><input type="text" name="ipl" size="10">
</form>
<?php
}
hardexit();
?> 
