// helper functions for navigating around listed files
//
var lastpage = 0;		// number of pages listed (set at end of load)

function gotoPage(page)		// scroll to page and then display new page list
{	
	if (page > lastpage) page = lastpage;
	if (page < 1) page = 1;

	var element_to_scroll_to = document.getElementById(page);
	element_to_scroll_to.scrollIntoView();
	displayPageList(page);
}

function setPageCount(last)
{
		lastpage = last;
}

function enteredPage()		// goto user entered page
{
	    var page = document.getElementById('gotopage').value;
		if (page >= 1 && page <= lastpage)
		{
			gotoPage(Number(page));
		}
		else
		{
			alert("Page to goto must be between 1 and " + lastpage);
			document.getElementById('gotopage').value = "";
			return;
		}
}

function min(a, b) { return ((a <= b) ? a : b); }
function max(a, b) { return ((a >= b) ? a : b); }

// build a new list of pages that are near to existing page and replace within
// <div> on existing screen. Hard work is to make a sensible choice of pages
// to provide quick links to.
function displayPageList(page)
{
	var pageList = ""; 	// string containing full list of clickable pages
	var p;
	
	if (page > lastpage)
			page = lastpage;	// just in case
	
	if (lastpage < 21)			// show all pages
	{
			for (p = 1 ; p <= lastpage; p++)
				pageList += makeUrl(p) + " ";
	} 
	else
	{		var low, high;
			pageList = makeUrl(1);
			low = max(2, page - 3); high = min(page + 15, lastpage);
			if (low > 20)
				pageList += makeUrl(page - 10) + " ";
			for (p = low; p < high ; p++)
					pageList += makeUrl(p) + " ";
			if (page < (lastpage - 30))
				pageList += makeUrl(page + 20) + " ";
			pageList += makeUrl(lastpage);
	}
	// replace html in div with this new list
	document.getElementById("pagelist").innerHTML  = pageList;
}

function makeUrl(page)   	// build clickable URL to call JS function
{		
		return "<a href=\"#" + page + "\" onclick=\"gotoPage(" + page + ");\">" + ((page == lastpage) ? page + "/last" : page) + "</a>&nbsp;\n";
}
