<?php
//Generate text file on the fly
// List the file provided on the link

require_once("../lib/common.php");

$authorised = check_auth_ok("output");

if( ! $authorised ) {
	header('HTTP/1.0 401 Unauthorized');
	echo "<h1>You don't have sufficient privileges to download output.</h1>";
	exit(1);
}
require_once("../lib/job_class.php");
require_once("../lib/colours.php");
require_once('../lib/greenbar.php');		// extends brilliant base class from fpdf.org

ini_set('max_execution_time', 300); //300 seconds = 5 minutes, required for pi when processing hasp assembly listing

$dtype = $_REQUEST["download"];
list($class, $type, $job) = getRequest();
if ($class == "LOG")
{
	$fp = fopen($CONSOLE_PATH, "r") or die("Unable to open console printer");
	$mtime = filemtime($CONSOLE_PATH);
	$name = "CONSOLE_LOG.lst";
	caching_headers($name, $mtime);
	$bar_colour = "green";
} 
else
{
	$bar_colour = getBarColourName($class, $type);
	
	$mvsprint = new jobOutput($PRT_DIR);
	$jobData = $mvsprint->getJobData($class, $type, $job) or die("Unable to open job ".$job);
	$mtime = $jobData['mtime'];
	
	caching_headers("$dtype /$class/$type/$job", $mtime);
 
	$fp = $mvsprint->getJobFP($class, $type, $job) ;;

	$name = $job;
}	

if ($_REQUEST["download"] == "pdf")
{
	$layout = (isset($_REQUEST["layout"]) ?  $_REQUEST["layout"] : "L");
	$size =   (isset($_REQUEST["size"]) ?  $_REQUEST["size"] : $MVSControl["pagesize"]);
	$font =   (isset($_REQUEST["font"]) ?  $_REQUEST["font"] : $FONT );
	
	try {
		$pdf = new PDF_GreenBar($layout, $size, $font);
		$pdf->setColour(getBarColourRGB($bar_colour));
		$pdf->PDFfromFP($fp);
		$pdf->Output('D', preg_replace("/\.lst$/", ".pdf", $name));
	} catch(Exception $e) {
		echo "Cannot process PDF download request.".$e->getMessage()."\n";
		exit;
	}
}
else if ($_REQUEST["download"] == "text")
{
	header("Content-type: text/plain; charset=ANSI");
	header("Content-Disposition: attachment; filename=$name");
	flush(); 
	
	$outfile = fopen("php://output", "w") or die("Cannot open browser stream");
	while( $l = fread($fp, 8192)) {
		fwrite($outfile, $l);
	}
	fclose($outfile);
	fclose($fp);
} else
	die("Unknown download type: ".$_REQUEST["type"]);
?>
