<?php
// List the file provided on the link

require_once("../lib/common.php");
$authorised = check_auth_ok("output");

if( ! $authorised ) {
	header('HTTP/1.0 401 Unauthorized');
	echo "<h1>You don't have sufficient privileges to display output.</h1>";
	exit(1);
}

require_once("../lib/job_class.php");
require_once("../lib/list_html.php");
require_once("../lib/colours.php");

ini_set('max_execution_time', 300); //300 seconds = 5 minutes, required for pi when processing hasp assembly listing

list($class, $type, $job) = getRequest();
$bar_colour_name = getBarColourName($class, $type);
		
$mvsprint = new jobOutput($PRT_DIR);
$jobData = $mvsprint->getJobData($class, $type, $job);

caching_headers("LIST /$class/$type/$job", $jobData['mtime']);

$jobfp = $mvsprint->getJobFP($class, $type, $job);
if ( ! $jobfp)
{
	die("Cannot open print input file $class $type $job");
}

$title =        "Output ($class/$type/" . basename($job, ".lst").")";
$description =  "Class: $class Type: $type Job: " . basename($job, ".lst");
$url_selector = "&class=$class&type=$type&job=$job&colour=$bar_colour_name";

list_html($jobfp, $title, $description, $url_selector, getBarColourHex($bar_colour_name));
?>
