<?php
// rdr - display a form for a user to submit a MVS job via the Hercules reader socket
// 
// sample buttons are provided to show different languages to help users get started
// as well as a button to select local files from the users environment
//
require_once("../lib/common.php");
$authorised = check_auth_ok("reader");

if( ! $authorised ) {
	header('HTTP/1.0 401 Unauthorized');
	echo "<h1>You don't have sufficient privileges to access the reader.</h1>";
	exit(1);
}
	
?>
<!DOCTYPE html>
<html>
<head>
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>
MVS Card Reader (<?php echo gethostname(); ?>)
</title>
<link rel="stylesheet" type="text/css" href="../lib/core.css" media="screen" >
</head>
<body>
<?php
// if passed a set of cards via the form submit it, otherwise display a blank submission form
$msg = "&nbsp;";

$jcluser = isset($_SESSION['mvsname']) ? $_SESSION['mvsname'] : "";
$jclpass = "";
$cards = "";	

if ( isset($_REQUEST['jcluser'])) {
	$jcluser = $_REQUEST['jcluser'];
}
if ( isset($_REQUEST['jclpass'])) {
	$jclpass = $_REQUEST['jclpass'];
}
if ( isset($_REQUEST['cards'])) {
	$cards = $_REQUEST['cards'];
	if ($cards == "") {
		$msg = "No cards read.";
	} else {	
		$rdrfp = @stream_socket_client($HERC_RDR_SOCK, $errno, $errstr);
		if ($rdrfp) {
			$subcards = $cards;	// copy so we leave the original cards untouched
			if ( $jcluser != "")
				$subcards = str_replace("%user%", strtoupper("$jcluser"), $subcards);
			if ( $jclpass != "")
				$subcards = str_replace("%pass%", strtoupper("$jclpass"), $subcards);
			fputs($rdrfp, $subcards);
			fclose($rdrfp);
			$msg = "Job submitted.";
		} else {
			$msg = "Cannot connect to $HERC_RDR_SOCK. $errstr ($errno).";
		}
	}
}
// if JCL is set then read the file from the jcl directory and prefill the cards textarea
else if (strlen($JCL_DIR) > 0 && isset($_REQUEST['jcl'])) {
		$clean_fname = preg_replace('((^\.)|\/|(\.$))', '_', $_REQUEST['jcl']);	// clean
		$fname = "$JCL_DIR/$clean_fname.jcl";
		
		if ($jcl_str = @file_get_contents($fname)) {
			$cards = $jcl_str;
		} else {
			$msg = "Cannot open JCL template file $clean_fname.jcl";
		}
}
?>
<script type="text/javascript">
function getSample(jcl) {
	// retrieve sample jcl by issuing a post to preserve jcluser and jclpass if set
	var form = document.createElement("form");
	form.setAttribute("method", "post");
	form.setAttribute("action", "<?php echo $_SERVER["PHP_SELF"] ?>");

        var hiddenField = document.createElement("input");
        hiddenField.setAttribute("type", "hidden");
        hiddenField.setAttribute("name", "jcl");
        hiddenField.setAttribute("value", jcl);
        form.appendChild(hiddenField);
	
	hiddenField = document.createElement("input");
        hiddenField.setAttribute("type", "hidden");
        hiddenField.setAttribute("name", "jcluser");
        hiddenField.setAttribute("value", document.getElementById("jcluser").value);
        form.appendChild(hiddenField);
	
	hiddenField = document.createElement("input");
        hiddenField.setAttribute("type", "hidden");
        hiddenField.setAttribute("name", "jclpass");
        hiddenField.setAttribute("value", document.getElementById("jclpass").value);
        form.appendChild(hiddenField);

	document.body.appendChild(form);
	form.submit();
	document.getElementById("cards").focus();
}

  function readSingleFile(evt) {
    //Retrieve the first (and only!) File from the FileList object
    var f = evt.target.files[0]; 

    if (window.File && window.FileReader && f) {
      var r = new FileReader();
      r.onload = function(e) { 
        document.getElementById("msg").innerHTML = "Local file read ok";
	document.getElementById("cards").value = r.result;	
      }
      r.readAsText(f);
 
    } else { 
         document.getElementById("msg").innerHTML = "Could  not open local file";
    }
  }
</script>
<?php
	do_header("MVS Reader");
?>
<nav>
<?php 	show_nav("reader", "..");
	if (strlen($HERC_RDR_SOCK) == 0)
		$msg = "No RDR devices defined. Cannot submit card jobs.";
?>
<br><b>Code Templates</b><br><br>
<label class="fileLabel">
	<input type="file" id="fileinput" style='position: fixed;top:-1000px;'>
    <span class="button">Local JCL</span>
</label>
<br><br>
<?php
if (strlen($JCL_DIR) > 0)
	foreach (glob("$JCL_DIR/*.jcl") as $filename)
		echo "<input type=\"button\" class=\"button\" value=\"".basename($filename, ".jcl")."\" onclick=\"getSample('".basename($filename, ".jcl")."')\">\n";
?> 
</nav>
<article>
<b><div id="msg"><font color="red"><?php echo $msg; ?></font color="black"><br></div></b><br>
<b>Enter Job Below</b><br>
<form name="job" action="" method="POST">
<input type="submit" value="Submit Job"  class="big_button" style='display:inline; background-color:green;'>
<input type="button" value="Clear cards" onclick='document.getElementById("cards").value = ""; document.getElementById("cards").focus();' class="big_button"  style='display: inline;' >&nbsp;&nbsp;
%user%=<input type="text" id="jcluser" name="jcluser" value="<?php echo $jcluser;?>" size="8" maxlength="8">&nbsp;&nbsp; 
%pass%=<input type="password" id="jclpass" name="jclpass" value="<?php echo $jclpass;?>" size="8" maxlength="8">
<br><br>
<textarea id="cards" name="cards" rows="20" cols="90" wrap="off" style="overflow-y: scroll;"  >
<?php echo $cards;?>
</textarea>

<script>
  document.getElementById('fileinput').addEventListener('change', readSingleFile, false);
  document.getElementById("cards").focus();
</script>
</script>
</form>
</article>
</body>
</html>